//	vo.ch - Some VO compatibility
//
//	Written by:	John M. Skelton,  Oct-94.
//
//	Copyright (C) 1994 Skelton Software, Kendal Cottage, Hillam, Leeds LS25 5HP, UK.
//	All Rights Reserved.
//
//	Part of Clip-4-Win.

#ifndef	C4W_VO_CH
#define	C4W_VO_CH

// Crude AS <type> syntax:

//#xcommand LOCAL <v,...> AS <type:ANY,ARRAY,BLOCK,BYTE,CODEBLOCK,DATE,	;
//                            DWORD,FLOAT,INT,LOGIC,LONG,LONGINT,OBJECT,	;
//                            PSZ,PTR,REAL4,REAL8,SHORT,SHORTINT,STRING,	;
//                            SYMBOL,USUAL,WORD>				;
//       => LOCAL <v>

#xcommand LOCAL <v,...> AS <type>					;
       => LOCAL <v>

#xcommand STATIC GLOBAL <v,...> [AS <type>]				;
       => STATIC <v>

#xcommand DEFINE <v> := <e> [AS <type>]					;
       => #DEFINE <v> <e>

#ifndef	FALSE
#define	FALSE	.F.
#endif

#ifndef	TRUE
#define	TRUE	.T.
#endif

#define	ArrayNew	Array

#xtranslate AScanExact( <a>, <x> )	=>	AScan( <a>, {|_e| _e == <x>} )

#xtranslate AEvalOld		=>	AEval

#xtranslate ClassName(<o>)	=>	<o>:ClassName

#xtranslate Default(@<v>, <x>)	=>	<v> := IIF(<v> == NIL, <x>, <v>)

#xtranslate IsObject(<x>)	=>	(ValType(<x>) == "O")

#xtranslate MemAlloc(<n>)	=>	Space(<n>)
#xtranslate MemFree(<p>)	=>	<p> := NIL

#xtranslate PSZ(<c>)		=>	(<c>)
#xtranslate PSZ2String(<c>)	=>	Left(<c>, At(Chr(0), <c>) - 1)
#xtranslate String2PSZ(<c>)	=>	(<c> + Chr(0))

#endif	// C4W_VO_CH
